#include "zcommon.acs"
#library "PlasmidDM"
#define PLASMID_RECOIL              312 //thanks samsara*.pk3 for execution

function int pow(int x, int y)
{
    int n = 1;
    while (y-- > 0) { n *= x; }
    return n;
}
function int itof(int x) { return x << 16; }
function int ftoi(int x) { return x >> 16; }

function void saveCVar(int cvar, int val)
{
    ConsoleCommand(StrParam(s:"set ", s:cvar, s:" ", d:val));
    ConsoleCommand(StrParam(s:"archivecvar ", s:cvar));
}

function int defaultCVar(int cvar, int defaultVal)
{
    int ret = GetCVar(cvar);
    if (ret == 0) { saveCVar(cvar, defaultVal); return defaultVal; }

    return ret;
}

script PLASMID_RECOIL (int degrees, int ticsup, int ticsdown) clientside
{
    if (defaultCVar("plasmiddm_cl_norecoil", 0) == 1) { terminate; }

    degrees = itof(degrees);
    if (degrees < 0) { degrees /= -100; }

    int qCurve, oldPitch, newPitch, pitchDiff, i;
    int amplitude = degrees / 2;

    if (ticsup > 0)
    {
        qCurve = degrees / pow(ticsup, 2);  // this is a
        newPitch = qCurve * pow(ticsup, 2);

        for (i = 0; i < ticsup; i++)
        {
            oldPitch = newPitch;
            // y = a(x-h)**2 + k
            newPitch = qCurve * pow((i+1)-ticsup, 2);
            pitchDiff = (newPitch - oldPitch) / 360;

            SetActorPitch(0, GetActorPitch(0) + pitchDiff);
            Delay(1);
        }
    }
    else
    {
        SetActorPitch(0, GetActorPitch(0) - (degrees / 360));
    }

    if (ticsdown > 0)
    {
        if (defaultCVar("samsara_cl_sinerecoil", 0) == 0)
        {
            qCurve = -degrees / pow(ticsdown, 2); // this is also a
            newPitch = qCurve * pow(ticsdown, 2);

            for (i = 0; i < ticsdown; i++)
            {
                oldPitch = newPitch;
                // y = a(x-h)**2 + k
                newPitch = qCurve * pow((i+1)-ticsdown, 2);
                pitchDiff = (newPitch - oldPitch) / 360;

                SetActorPitch(0, GetActorPitch(0) + pitchDiff);
                Delay(1);
            }
        }
        else
        {
            // y = (a/2) * sin(x) + (a/2)
            newPitch = 0;

            for (i = 0; i <= ticsdown; i++)
            {
                oldPitch = newPitch;
                newPitch = -FixedMul(amplitude, cos(itof(i) / (ticsdown*2))) + amplitude;
                pitchDiff = (newPitch - oldPitch) / 360;

                SetActorPitch(0, GetActorPitch(0) + pitchDiff);
                Delay(1);
            }
        }
    }
    else
    {
        SetActorPitch(0, GetActorPitch(0) + (degrees / 360));
    }
}
